/*
 * This Arduin to measure DC Current using The 75mV Shunt resistor for up 500A
 *  50A 75mV, 100A 75mV, 200A 75mV, 300A, 500A 
 * and displayes the current on LCD1602 or LCD2004 with I2C (or other LCD of these type)
 * 
 * Watch Video instrution for this code:https://youtu.be/xHe9RRQWMBM
 * 
 * Full explanation of this code and wiring diagram is available at
 * my Arduino Course at Udemy.com here: http://robojax.com/L/?id=62

 * Written by Ahmad Shamshiri on May 10, 2020 at 04:18 in Ajax, Ontario, Canada
 * in Ajax, Ontario, Canada. www.robojax.com
 * 

 * Get this code and other Arduino codes from Robojax.com
Learn Arduino step by step in structured course with all material, wiring diagram and library
all in once place. Purchase My course on Udemy.com http://robojax.com/L/?id=62

If you found this tutorial helpful, please support me so I can continue creating 
content like this. You can support me on Patreon http://robojax.com/L/?id=63

or make donation using PayPal http://robojax.com/L/?id=64

 *  * This code is "AS IS" without warranty or liability. Free to be used as long as you keep this note intact.* 
 * This code has been download from Robojax.com
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.


*/

const int SHUNT_IN_PIN =A0;//can change
const float SHUNT_CURRENT =100.00;//A
const float SHUNT_VOLTAGE =75.0;// mV
const int CORRECTION_VALUE = 3;
const int ITERATION = 10; //can change (see video)
const float VOLTAGE_REFERENCE = 1100.00;//1.1V
const int BIT_RESOLUTION =10;//and 12 for Due and MKR
const boolean DEBUG_ONCE = true;
const float MINIMUM_CURRENT = 5.0;

const int LCD_CHAR =20;
const int LCD_LINE = 4;
const int I2C_ADDRESS = 0x27;//I2C address watch video for details



// start of settings for LCD1602 with I2C
#include <Robojax_Energy_Meter.h>
// Set the LCD address to 0x27 for a 16 chars and 2 line display
//use I2C scanner file included with this libray to find the 0x27 or any other address for your module
Robojax_Energy_Meter shunt(
                   I2C_ADDRESS, LCD_CHAR, LCD_LINE,
                   SHUNT_IN_PIN,SHUNT_CURRENT, SHUNT_VOLTAGE,
                   CORRECTION_VALUE, ITERATION, VOLTAGE_REFERENCE,
                   BIT_RESOLUTION, MINIMUM_CURRENT, DEBUG_ONCE
                   );

                  
// end of settings for LCD1602 with I2C



// the setup routine runs once when you press reset:
void setup() {
  // initialize serial communication at 9600 bits per second:
  Serial.begin(9600);
  Serial.println("Robojax 500A Current for Arduino");
  shunt.begin();  
  shunt.backlight();
  shunt.print("Robojax Shunt");  
 
  
  //for line below see https://www.arduino.cc/reference/en/language/functions/analog-io/analogreference
  analogReference(INTERNAL);//1.1V internal reference
  //analogReadResolution(BIT_RESOLUTION);//only Arduino with Due and MKR
  delay(500);
}

// the loop routine runs over and over again forever:
void loop() {
 //robojax.com 500A Shunt Current Measurement for Arduino
 shunt.showCurrent();
 Serial.println(shunt.getCurrent());
  //shunt.printDebug();
  //shunt.printSerial();
  delay(1000);
}



 